SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'TLA 10/4/2012 14:39' prior: 0!
I am a cell of the board game Quinto!

!SBECell methodsFor: 'initialization' stamp: 'TLA 10/4/2012 15:16'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!SBECell methodsFor: 'accessing' stamp: 'TLA 10/5/2012 11:21'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'TLA 10/5/2012 11:23'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame commentStamp: 'TLA 10/4/2012 15:29' prior: 0!
The Quinto game object!

!SBEGame methodsFor: 'initialization' stamp: 'TLA 10/4/2012 15:58'!
cellsPerSide
	"The number of cells along each side of the board game"
	^ 10! !

!SBEGame methodsFor: 'initialization' stamp: 'TLA 10/4/2012 15:51'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'initialization' stamp: 'TLA 10/5/2012 12:27'!
newCellAt: i at: j 
	"Create a cell for position (i,j) and add it to my on-screen
	representation at the appropriate screen position. Answer the new cell "
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: i - 1 * c width @ (j - 1 * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!SBEGame methodsFor: 'game logic' stamp: 'TLA 10/4/2012 16:15'!
toggleNeighboursOfCellAt: i at: j
(i > 1) ifTrue: [(cells at: i -1 at: j) toggleState].
(i < self cellsPerSide) ifTrue: [(cells at: i + 1 at: j) toggleState].
(j > 1) ifTrue: [(cells at: i at: j - 1) toggleState].
(j < self cellsPerSide) ifTrue: [(cells at: i at: j + 1) toggleState].! !
